

/*
 cc -g -c imvmapper.c
*/

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>


#include "../s_tools/smem.h"
#include "../s_tools/sfile.h"

#include "imvguard.h"
#include "imvmapper.h"


/* -------------------------------- ImvmappeR ------------------------------ */


int Imvmapper_new(mapper,guard,cmd,glue_character,flag)
struct ImvmappeR **mapper;
struct ImvguarD *guard;
char *cmd;
char glue_character;
int flag;
{
 int ret;
 struct ImvmappeR *m;

 *mapper= m= TSOB_FELD(struct ImvmappeR,1);
 if(m==NULL)
   return(-1);
 m->guard= guard;
 m->agent= guard->agent;
 strcpy(m->cmd,cmd);
 m->glue_character= glue_character;
 m->count= 0;
 return(1);
failed:;
 Imvmapper_destroy(mapper,0);
 return(ret);
}


int Imvmapper_destroy(mapper,flag)
struct ImvmappeR **mapper;
int flag;
{
 if(*mapper==NULL)
   return(0);
 Smem_freE((char *) *mapper);
 *mapper= NULL;
 return(1);
}


int Imvmapper_op_file(mapper,op,adr,flag)
struct ImvmappeR *mapper;
char *op;
char *adr;
int flag;
{
 int ret,status;
 char cmd[SfileadrL];
 struct Sfile_popeN *result,result_data;
 
 result= &result_data;
 sprintf(cmd,"%s -%s%c",mapper->cmd,op,mapper->glue_character);
 Sfile_esc_shell(adr,cmd+strlen(cmd),0);
 ret= Asagent_shell(mapper->agent,cmd,&status,0);
 if(ret<0)
   return(ret);
 return(1);
}


int Imvmapper_append(mapper,adr,flag)
struct ImvmappeR *mapper;
char *adr;
int flag;
{
 int ret;

 ret= Imvmapper_op_file(mapper,"append",adr,0);
 return(ret);
}


int Imvmapper_refresh(mapper,adr,flag)
struct ImvmappeR *mapper;
char *adr;
int flag;
{
 int ret;

 ret= Imvmapper_op_file(mapper,"refresh",adr,0);
 return(ret);
}


int Imvmapper_del_file(mapper,adr,flag)
struct ImvmappeR *mapper;
char *adr;
int flag;
{
 int ret;

 ret= Imvmapper_op_file(mapper,"del_file",adr,0);
 return(ret);
}


int Imvmapper_op_file_reply(mapper,adr,op,filec,filev,flag)
struct ImvmappeR *mapper;
char *adr;
char *op;
int *filec;
char ***filev; /* has to be NULL if not pointing to disposable dynamic memory */
int flag;
{
 int ret;
 char cmd[SfileadrL];
 struct Sfile_popeN *result,result_data;
 
 result= &result_data;
 if(*filec>0 && *filev!=NULL){
  /* release previously created result structure */
   result_data.count= *filec;
   result_data.lines= *filev;
   Sfile_popen_cleanup(result,0);
 }
 *filec= 0;
 *filev= NULL;
 sprintf(cmd,"%s -%s%c",mapper->cmd,op,mapper->glue_character);
 Sfile_esc_shell(adr,cmd+strlen(cmd),0);
 ret= Sfile_popen_init(cmd,result,0);
 if(ret>0)
   Sfile_popen_checkout(result,filec,filev,0);
 Sfile_popen_cleanup(result,0);
 if(ret<0)
   return(ret);
 return(*filec>0);
}


int Imvmapper_search(mapper,adr,filec,filev,flag)
struct ImvmappeR *mapper;
char *adr;
int *filec;
char ***filev; /* has to be NULL if not pointing to disposable dynamic memory */
int flag;
{
 int ret;

 ret= Imvmapper_op_file_reply(mapper,adr,"search",filec,filev,0);
 return(ret);
}


int Imvmapper_lookup_adr(mapper,adr,filec,filev,flag)
struct ImvmappeR *mapper;
char *adr;
int *filec;
char ***filev; /* has to be NULL if not pointing to disposable dynamic memory */
int flag;
{
 int ret;
 
 ret= Imvmapper_op_file_reply(mapper,adr,"lookup_adr",filec,filev,0);
 return(ret);
}



