

/*
 cc -g -c saccess.c
*/

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include "smem.h"

#include "saccess.h"


/* ----------------------------- SaccessiteM ------------------------------ */


int Saccessitem_new(item,topic,target,property,value,prev,flag)
struct SaccessiteM **item;
char *topic;
char *target;
char *property;
char *value;
struct SaccessiteM *prev;
int flag;
{
 struct SaccessiteM *it;
 
 *item= it= TSOB_FELD(struct SaccessiteM,1);
 if(it==NULL)
   return(-1);
 it->topic= it->target= it->property= it->value= NULL;
 it->prev= it->next= NULL;
 if(Sregex_string(&(it->topic),topic)<=0)
   goto failed;
 if(Sregex_string(&(it->target),target)<=0)
   goto failed;
 if(Sregex_string(&(it->property),property)<=0)
   goto failed;
 if(Sregex_string(&(it->value),value)<=0)
   goto failed;
 if(prev!=NULL) {
   if(prev->next!=NULL) {
     prev->next->prev= it;
     it->next= prev->next;
   }
   it->prev= prev;
   prev->next= it;
 }
 return(1);
failed:;
 Saccessitem_destroy(item,0);
 return(-1);
}


int  Saccessitem_destroy(item,flag)
struct SaccessiteM **item;
int flag;
{
 struct SaccessiteM *it;
 
 it= *item;
 if(it==NULL)
   return(0);
 Sregex_string(&(it->topic),NULL,0);
 Sregex_string(&(it->target),NULL,0);
 Sregex_string(&(it->property),NULL,0);
 Sregex_string(&(it->value),NULL,0);
 if(it->prev!=NULL)
   it->prev->next= it->next;
 if(it->next!=NULL)
   it->next->prev= it->prev;
 Smem_freE((char *) it);
 *item= NULL;
 return(1);
}
 

/* -------------------------------- SaccesS -------------------------------- */


int Saccess_new(access,flag)
struct SaccesS **access;
int flag;
{
 int ret;
 struct SaccesS *a;
 
 *access= a= TSOB_FELD(struct SaccesS,1);
 if(a==NULL)
   return(-1);

 a->itemlist= NULL;
 a->itemcount= 0;

 ret= Saccessitem_new(&(a->itemlist),"head","head","head","",NULL,0);
 if(ret<=0)
   goto failed;
 a->itemcount= 1;
 return(1);
failed:;
 Saccess_destroy(access,0);
 return(-1);
}


int Saccess_destroy(access,flag)
struct SaccesS **access;
int flag;
{
 struct SaccessiteM *current,*next;

 if(*access==NULL)
   return(0);
 current= (*access)->itemlist;
 while(current!=NULL) {
   next= current->next;
   Saccessitem_destroy(&current,0);
   current= next;
 }
 Smem_freE((char *) *access);
 *access= NULL;
}


int Saccess_append(access,topic,target,property,value,flag)
struct SaccesS *access;
char *topic;
char *target;
char *property;
char *value;
int flag;
{
 int ret;
 struct SaccessiteM *current= NULL;
 
 if(access==NULL)
   return(0);
 ret= Saccessitem_new(&current,topic,target,property,value,access->itemlist,0);
 access->itemcount++;
 return(ret);
}


int Saccess_find_item(access,topic,target,property,value,found,flag)
struct SaccesS *access;
char *topic;
char *target;
char *property;
char *value;
struct SaccessiteM **found;
int flag;
/*
 bit0= find last matching item rather than first one
 bit1= do compare value
 bit2= compare property by strncmp and make sure that no / follows
*/
{
 struct SaccessiteM *current,*next;
 int count= 0;

 *found= NULL;
 if(access==NULL)
   return(0); 
 for(current= access->itemlist; current!=NULL; current= next) {
   count++;
   next= current->next;
   if(strcmp(current->topic,topic)!=0
      && strcmp(current->topic,"all")!=0 && strcmp(topic,"any")!=0)
 continue;
   if(strcmp(current->target,target)!=0
      && strcmp(current->target,"all")!=0 && strcmp(target,"any")!=0)
 continue;
   if(strcmp(current->property,"all")!=0 && strcmp(property,"any")!=0) {
     if(flag&4) {
       if(strlen(current->property)>0)
         if(strncmp(current->property,property,strlen(current->property))!=0)
 continue;
       if(strchr(property+strlen(current->property),'/')!=NULL)
 continue;
     } else {
       if(strcmp(current->property,property)!=0)
 continue;
     }
   }
   if(flag&2)
     if(strcmp(current->value,value)!=0)
 continue;
   *found= current;
   if(!(flag&1))
     return(count+1);
 }
 if((*found)!=NULL)
   return(count+1);
 return(0);
}


int Saccess_find_value(access,topic,target,property,value,flag)
struct SaccesS *access;
char *topic;
char *target;
char *property;
char **value;
int flag;
/*
 bit0= find last matching item rather than first one
 bit2= for Saccess_find_item : strncmp() and not / in remainder
*/
{
 struct SaccessiteM *found;
 int ret;
 
 *value= NULL;
 ret= Saccess_find_item(access,topic,target,property,"",&found,flag&(1|4));
 if(ret<=0)
   return(ret);
 *value= found->value;
 return(ret);
}


int Saccess_find_keydir(access,target,value,flag)
struct SaccesS *access;
char *target;
char **value;
int flag;
{
 int ret;
 
 if(access==NULL)
   return(0);
 ret= Saccess_find_value(access,"connection",target,"keydirectory",value,0);
 return(ret);
}


int Saccess_consume_last(access,topic,target,property,property_found,value,flag)
struct SaccesS *access;
char *topic;
char *target;
char *property;
char **property_found;
char **value;   /* has to be NULL or pointing to disposable malloced data */ 
int flag;
{
 int ret;
 struct SaccessiteM *found;
 
 ret= Saccess_find_item(access,topic,target,property,"",&found,1);
 if(ret<=0)
   return(ret);
 if(Sregex_string(property_found,found->property,0)<=0)
   return(-1);
 if(Sregex_string(value,found->value,0)<=0)
   return(-1);
 Saccessitem_destroy(&found,0);
 return(1);
}


